//-------------------------------------------------------------------------------
//      USB2IO Ver1.00
//
//
//                                              Software design    : Masaru Osuga
//                                                         DATE    :  2008/08/05 
//
// Reorganization history--------------------------------------------------------
// Ver1.00		2008/08/05		New Software release.            
//-------------------------------------------------------------------------------

#pragma     jis

#include	<m8c.h>        // part specific constants and macros
#include 	"PSoCAPI.h"    // PSoC API definitions for all User Modules
#include	"stdio.h"
#include	"string.h"
#include    "ctype.h"


#define		TXBUFSIZE	32
#define		RXBUFSIZE	32

//#define		NULL		0
#define		EOS		    0x00
#define		CTRL_A		0x01
#define		CTRL_C		0x03
#define		CTRL_S		0x13
#define		CTRL_Q		0x11
#define		CTRL_R		0x12
#define		CTRL_Z		0x1a
#define		CR		    0x0d
#define		LF		    0x0a
#define		BS		    0x08
#define		DEL		    0x7f
#define		TAB		    '\t'
#define		SPACE		' ' 

#define	    E_READY		0
#define	    E_ERRVAL	1
#define	    E_ERRCMD	2

#pragma abs_address:0x100
unsigned char	TX_buf[TXBUFSIZE];
unsigned char	RX_buf[RXBUFSIZE+1];
unsigned char	Cmd_buf[RXBUFSIZE+1];
unsigned char   disp_buf[RXBUFSIZE];
#pragma end_abs_address

unsigned char	TX_pos;
unsigned char 	Cmd_pos;
unsigned char	RX_pos = 0; 	// rxbufoĂꏊ
unsigned char	RX_count = 0;	// rxbufɓĂf[^
unsigned char   disp_pos = 0;
//----------------------------------------------------------------
//   GP-IB      
//----------------------------------------------------------------
//@@|[gO@@@@@@@@@@//@@|[gQ@@@@@@@@
//@@@@O(24)@chnP( 1)    //@@@@O(20)@@qdm(17)@Remote enable
//@@@@P( 4)@chnQ( 2)    //@@@@P( 8)@@heb( 9)@Interface clear
//@@@@Q(25)@chnR( 3)    //@@@@Q(21)@mc`b( 8)@Not data accepted
//@@@@R( 3)@chnS( 4)    //@@@@R( 7)@mqec( 7)@Not Ready For Data.
//@@@@S(26)@chnT(13)    //@@@@S(22)@@c`u( 6)@Data valid
//@@@@T( 2)@chnU(14)    //@@@@T( 6)@@dnh( 5)@End-or-identify
//@@@@U(27)@chnV(15)    //@@@@U(23)@@`sm(11)@Attention
//@@@@V( 1)@chnW(16)    //@@@@V( 5)@@rqp(10)@Service request

#define     REN     0x00
#define     IFC     0x01
#define     NDAC    0x02
#define     NRFD    0x03
#define     DAV     0x04
#define     EOI     0x05
#define     ATN     0x06
#define     SRQ     0x07

#define     TALK_ONLY_MODE  1
#define     LISEN_ONLY_MODE 2


void initial_msg(void)
{
	printf("READY\r\n");
    PRT3DR ^= 0x40;
}


void wait(long l){ while(l--); }

void	putch(unsigned char c)
{
/*	char	str[] = " ";
//	if(c != '\n'){
		strncpy(str,&c,1);
		while (!USBUART_bTxIsReady()); //If TX is ready  
	//	USBUART_PutChar(*str);          //2008.08.18 changed  */
    while (!USBUART_bTxIsReady()); //If TX is ready
        USBUART_PutChar(c);
/*	} 
    if(c == '\n'){
	while (!USBUART_bTxIsReady()); //If TX is ready  
	    USBUART_PutChar(CR);
	    USBUART_PutChar(LF);
	    
	}*/
}

void	get_data(void)
{
	unsigned char brk,c;
	brk = 0;
	Cmd_pos = 0;                    
	while(1) {                      // 
		while ((RX_pos < RX_count) && !brk) {
			if (Cmd_pos >= RXBUFSIZE) {
				brk = 1;
				break;
			}
			switch(c = (Cmd_buf[Cmd_pos] = RX_buf[RX_pos])) {
				case	LF:	
			                RX_pos++;	
			                printf("%c",LF);
						    break;
				case	CR:	
			                RX_pos++;	
						    brk = 1;
			                printf("%c",CR);
						    break;
				case	BS:	
			                if (Cmd_pos) {	
							Cmd_pos--;
							printf("%c",BS);
						    }
						    RX_pos++;
						    break;
				case	EOS:
			                break;		
				default:	Cmd_pos++;	
						    RX_pos++;
						    printf("%c",c);
						    break;
			}
		}
	    if (brk) {
			Cmd_buf[Cmd_pos] = EOS;
			printf("\n");
			break;
		}
		
		RX_pos = 0;
		while(!(RX_count = USBUART_bGetRxCount()))
			;
		USBUART_ReadAll(&RX_buf[RX_pos]);
	}
	return;
}



//----------------------------------------
//-- ȈՃwv				--
//----------------------------------------
void exec_help()
{
	
    printf("gF\r\n");
    printf("yoz@|[g̃[hZbg܂@\r\n");
    printf("@oP@hP@@@@@@@@@@@@@\r\n");
    printf("@@@@@O`Vrbg@`@@@\r\n");
    printf("@@@@@h́@nó@@@@@@\r\n");
    printf("@@@@@O`Q|[gԍ@@@@@\r\n");
    printf("@@@@@@@@@@@@@@@@@@@\r\n");
    printf("yvz@|[gɏo͂܂@@@@@@\r\n");
    printf("@vP@gP@@@@@@@@@@@@@\r\n");
    printf("@@@@@O`Vrbg@`@@@\r\n");
    printf("@@@@@giPj@kiOj@@@@\r\n");
    printf("@@@@@O`Q|[gԍ@@@@@\r\n");
    printf("@@@@@@@@@@@@@@@@@@@\r\n");
    printf("yqz@|[g͂܂@@@@@\r\n");
    printf("@vP@@@@@@@@@@@@@@@@\r\n");
    printf("@@@@@O`Q|[gԍ@@@@@\r\n");
    printf("@@@@@@`@@@@@@@@@@\r\n");
    printf("\r\n");
    
}

void port_mode_set(void)
{   unsigned char c,m,b,d;
    c = Cmd_buf[1];     //|[g mDOCPCQ
    m = Cmd_buf[3];     //[h@͂h,i@oO,o
    d = Cmd_buf[4]-'0'; //rbg@Hex 0-7
    b = Cmd_buf[4];     //rbg@0-7 or A,a
    if ((b == 'a')||(b == 'A')) b=0xff;     //set all bit
    else{   if((b < '0')||(b > '7')){
                printf("ERROR BitSet is 1-8 or A\r\n");
                return; }
            b =0x01<<( b - '0');         }
    switch(c){
        case '0':   if((m =='i')||(m=='I')){
                        if(b==0xff)printf("|[g0̓[hɃZbg܂B\r\n");
                        else printf("|[g0_%d̓[hɃZbg܂B\r\n",d);
                        PRT0DM0 &= ~b;PRT0DM1 |= b;PRT0DM2 &= ~b;   }
                    if((m =='o')||(m=='O')){
                        if(b==0xff)printf("|[g0o̓[hɃZbg܂B\r\n");
                        else printf("|[g0_%do̓[hɃZbg܂B\r\n",d);
                        PRT0DM0 |= b;PRT0DM1 &= ~b;PRT0DM2 &= ~b;    }
                    break;
        case '1':   if((m =='i')||(m=='I')){
                        if(b==0xff)printf("|[g1̓[hɃZbg܂B\r\n");
                        else printf("|[g1_%d̓[hɃZbg܂B\r\n",d);
                        PRT1DM0 &= ~b;PRT1DM1 = b;PRT1DM2 &= ~b;    }
                    if((m =='o')||(m=='O')){
                        if(b==0xff)printf("|[g1o̓[hɃZbg܂B\r\n");
                        else printf("|[g1_%do̓[hɃZbg܂B\r\n",d);
                        PRT1DM0 |= b;PRT1DM1 &= ~b;PRT1DM2 &= ~b;    }
                    break;
        case '2':   if((m =='i')||(m=='I')){
                        if(b==0xff)printf("|[g2̓[hɃZbg܂B\r\n");
                        else printf("|[g2_%d̓[hɃZbg܂B\r\n",d);
                        PRT2DM0 &= ~b;PRT2DM1 = b;PRT2DM2 &= ~b;   }
                    if((m =='o')||(m=='O')){
                        if(b==0xff)printf("|[g2o̓[hɃZbg܂B\r\n");
                        else printf("|[g2_%do̓[hɃZbg܂B\r\n",d);
                        PRT2DM0 |= b;PRT2DM1 &= ~b;PRT2DM2 &= ~b;    }
                    break;
        default :   printf("MODE SET ERROR\r\n");
    }
}

void port_read(void)
{
    unsigned char c,data;
   
    c = Cmd_buf[1];     //|[g mDOCPCQ
    //printf("[%x]\r\n",c);
    
    switch(c){
        case '0':   data = PRT0DR;
                    printf("|[g0:%02x\r\n",data);
                    break;
        case '1':   data = PRT1DR;
                    printf("|[g1:%02x\r\n",data);
                    break;
        case '2':   data = PRT2DR;
                    printf("|[g2:%02x\r\n",data);
                    break;
        case 'A':
        case 'a':   data = PRT0DR; printf("|[g0:%02x\r\n",data);
                    data = PRT1DR; printf("|[g1:%02x\r\n",data);
                    data = PRT2DR; printf("|[g2:%02x\r\n",data);
                    break;
        default :   printf("PORT READ ERROR\r\n");
    }
}
void port_write(void)
{   unsigned char c,m,b,d;
    c = Cmd_buf[1];     //|[g mDOCPCQ
    m = Cmd_buf[3];     //[h@High(1) H,h@Low(0)L,l
    d = Cmd_buf[4]-'0'; //rbg@Hex 0-7
    b = Cmd_buf[4];     //rbg@0-7 or A,a
    if ((b == 'a')||(b == 'A')) b=0xff;     //set all bit
    else{   if((b < '0')||(b > '7')){
                printf("ERROR BitSet is 1-8 or A\r\n");
                return; }
            b =0x01<<( b - '0');         }
    switch(c){
        case '0':   if((m =='h')||(m=='H')){
                        if(b==0xff)printf("|[g0gɃZbg܂B\r\n");
                        else printf("|[g0_%dgɃZbg܂B\r\n",d);
                        PRT0DR |= b;     }
                    if((m =='l')||(m=='L')){
                        if(b==0xff)printf("|[g0kɃZbg܂B\r\n");
                        else printf("|[g0_%dkɃZbg܂B\r\n",d);
                        PRT0DR &= ~b;    }
                    break;
        case '1':   if((m =='h')||(m=='H')){
                        if(b==0xff)printf("|[g1gɃZbg܂B\r\n");
                        else printf("|[g1_%dgɃZbg܂B\r\n",d);
                        PRT1DR |= b;     }
                    if((m =='l')||(m=='L')){
                        if(b==0xff)printf("|[g1kɃZbg܂B\r\n");
                        else printf("|[g1_%dkɃZbg܂B\r\n",d);
                        PRT1DR &= ~b;  }
                    break;
        case '2':   if((m =='h')||(m=='H')){
                        if(b==0xff)printf("|[g2gɃZbg܂B\r\n");
                        else printf("|[g2_%dgɃZbg܂B\r\n",d);
                        PRT2DR |= b;     }
                    if((m =='l')||(m=='L')){
                        if(b==0xff)printf("|[g2kɃZbg܂B\r\n");
                        else printf("|[g2_%dkɃZbg܂B\r\n",d);
                        PRT2DR &= ~b;     }
                    break;
        default :   printf("WRITE SET ERROR\r\n");
    }
}


void GPIB_set_REN(void)
{
    PRT2DR |= (0x01 << REN);
}
void GPIB_reset_REN(void)
{
    PRT2DR &= ~(0x01 << REN);
}
char GPIB_check_REN(void)
{
    if((PRT2DR & (0x01 << REN)) == 0)
        return 0;
    else
        return 1;
}

void GPIB_set_IFC(void)
{
    PRT2DR |= (0x01 << IFC);
}
void GPIB_reset_IFC(void)
{
    PRT2DR &= ~(0x01 << IFC);
}
char GPIB_check_IFC(void)
{
    if((PRT2DR & (0x01 << IFC)) == 0)
        return 0;
    else
        return 1;
}

void GPIB_set_NDAC(void)
{
    PRT2DR |= (0x01 << NDAC);
}
void GPIB_reset_NDAC(void)
{
    PRT2DR &= ~(0x01 << NDAC);
}
char GPIB_check_NDAC(void)
{
    if((PRT2DR & (0x01 << NDAC)) == 0)
        return 0;
    else
        return 1;
}

void GPIB_set_NRFD(void)
{
    PRT2DR |= (0x01 << NRFD);
}
void GPIB_reset_NRFD(void)
{
    PRT2DR &= ~(0x01 << NRFD);
}
char GPIB_check_NRFD(void)
{
    if((PRT2DR & (0x01 << NRFD)) == 0)
        return 0;
    else
        return 1;
}

void GPIB_set_DAV(void)
{
    PRT2DR |= (0x01 << DAV);
}
void GPIB_reset_DAV(void)
{
    PRT2DR &= ~(0x01 << DAV);
}
char GPIB_check_DAV(void)
{
    if((PRT2DR & (0x01 << DAV)) == 0)
        return 0;
    else
        return 1;
}

void GPIB_set_EOI(void)
{
    PRT2DR |= (0x01 << EOI);
}
void GPIB_reset_EOI(void)
{
    PRT2DR &= ~(0x01 << EOI);
}
char GPIB_check_EOI(void)
{
    if((PRT2DR & (0x01 << EOI)) == 0)
        return 0;
    else
        return 1;
}

void GPIB_set_ATN(void)
{
    PRT2DR |= (0x01 << ATN);
}
void GPIB_reset_ATN(void)
{
    PRT2DR &= ~(0x01 << ATN);
}
char GPIB_check_ATN(void)
{
    if((PRT2DR & (0x01 << ATN)) == 0)
        return 0;
    else
        return 1;
}
void GPIB_set_SRQ(void)
{
    PRT2DR |= (0x01 << SRQ);
}
void GPIB_reset_SRQ(void)
{
    PRT2DR &= ~(0x01 << SRQ);
}
char GPIB_check_SRQ(void)
{
    if((PRT2DR & (0x01 << SRQ)) == 0)
        return 0;
    else
        return 1;
}

void GPIB_set_mode(char s){
    switch(s){
    case 1: //TALK_ONLY_MODE
                printf("TALK_ONLY_MODE\r\n");
                PRT0DM0 = 0x00;PRT0DM1 = 0xff;PRT0DM2 = 0x00;
                PRT2DM0 = 0x00;PRT2DM1 = 0xff;PRT2DM2 = 0x00;
            break;
    case 2: //LISEN_ONLY_MODE
                printf("LISEN_ONLY_MODE\r\n");
                PRT0DM0 = 0x00;PRT0DM1 = 0xff;PRT0DM2 = 0x00;
                PRT2DM0 = 0x00;PRT2DM1 = 0xff;PRT2DM2 = 0x00;
                PRT2DM0 |= (0x01 << NDAC);PRT2DM1 &= ~(0x01 << NDAC);PRT2DM2 &= ~(0x01 << NDAC);
                PRT2DM0 |= (0x01 << NRFD);PRT2DM1 &= ~(0x01 << NRFD);PRT2DM2 &= ~(0x01 << NRFD);
        
            break;
   default :   printf("GP-IB MODE ERROR\r\n");
    }
}

void GPIB_ALL_RESET(void)
{
    GPIB_reset_IFC();
    wait(1000);
    GPIB_set_IFC();
}

void status_read(void)
{
    printf("[status] ");
    printf("REN:%d ",GPIB_check_REN());
    printf("IFC:%d ",GPIB_check_IFC());
    printf("NDAC:%d ",GPIB_check_NDAC());
    printf("NRFD:%d ",GPIB_check_NRFD());
    printf("DAV:%d ",GPIB_check_DAV());
    printf("EOI:%d ",GPIB_check_EOI());
    printf("ATN:%d ",GPIB_check_ATN());
    printf("SRQ:%d ",GPIB_check_SRQ());
    printf("\r\n");
}
char GPIB_read_1_byte(void)
{
    char dat;
    GPIB_reset_NDAC();
    GPIB_reset_NRFD();
    while(!GPIB_check_DAV());   // DAV = H ?
    GPIB_set_NRFD();
    wait(20);
    while(GPIB_check_DAV());        // DAV = L ?
    wait(20);
    GPIB_reset_NRFD();
    dat = ~(PRT0DR);                // Data Get

    GPIB_set_NDAC();
    wait(20);
    while(!GPIB_check_DAV());       // DAV = H ?
    wait(20);
    GPIB_reset_NDAC();

    return dat;
}



void GPIB_read(void)
{   GPIB_set_mode(2);
    while(GPIB_check_EOI()){ 
        USBUART_PutChar(GPIB_read_1_byte());
        }
    printf("\r\n");
}

void GPIB_read_hex(void)
{   int c = 0;
    while(GPIB_check_EOI()){ 
        printf("%02X ",GPIB_read_1_byte());
        if ((c % 16) == 15){
              printf("\r\n"); 
        }
    c++;
    }
    printf("\r\n");
}
void main()  
{
	unsigned char   s;
    PRT0DM0 = 0x00;PRT0DM1 = 0xff;PRT0DM2 = 0x00;
    PRT1DM0 = 0x00;PRT1DM1 = 0xff;PRT1DM2 = 0x00;
    PRT2DM0 = 0x00;PRT2DM1 = 0xff;PRT2DM2 = 0x00;
    
	M8C_EnableGInt;                        //Enable Global Interrupts    
	USBUART_Start(USBUART_5V_OPERATION);   //Start USBUART 5V operation    
	while(!USBUART_Init());                //Wait for Device to initialize  
	
	get_data();
	printf("***** USB2GPIB Monitor Version 1.00 *****\r\n\n");
	while(1) {
		printf("COMMAND>");
		get_data();
		if( Cmd_buf[0] == EOS ) {		// 
			initial_msg();
		} 
	    if( Cmd_buf[0] != EOS ) {
			//printf("[%s]\r\n",Cmd_buf);
		    s = Cmd_buf[0];
	        switch( s ){
	            case 'p':
	            case 'P':   port_mode_set( );   break;
	            case 'r':
	            case 'R':   port_read();        break;
	            case 'w':
	            case 'W':   port_write();       break;
	            case ' ':   break;
	            case 's':
	            case 'S':   status_read();      break;
	            
	            case 'z':   printf("%c",GPIB_read_1_byte());    break;
	            case 'x':   GPIB_read();           break;
	            case 'X':   GPIB_read_hex();       break;
	            
	            case 'i':   
	            case 'I':   GPIB_ALL_RESET();   break;
	            case '1':   GPIB_set_mode(TALK_ONLY_MODE);   break;
	            case '2':   GPIB_set_mode(LISEN_ONLY_MODE);   break;
	            case '?':
	            case 'h':
	            case 'H':	exec_help();        break;
	            
	            default :   printf("COMMAND ERROR\r\n");
	        }
        }
    }
}
